#include "php_gtk.h"
#if HAVE_PHP_GTK



#include <gtkhtml/gtkhtml.h>
#include <gtkhtml/gtkhtml-embedded.h>
#include <gtkhtml/gtkhtml-embedded.h>
#include <gtkhtml/htmlengine-edit-fontstyle.h>
#include <gtkhtml/htmlengine-edit-cut-and-paste.h>
#include <gtkhtml/htmlcolor.h>
#include <gtkhtml/htmltypes.h>
#include <gtkhtml/htmlobject.h>
#include <gtkhtml/htmlcursor.h>
#include <gtkhtml/htmlengine-edit-movement.h>

#include "ext/gtk+/php_gtk+.h"
#include "ext/gtkhtml/php_gtkhtml.h"

/* Hack to make the enums work */
typedef enum {
      GTK_TYPE_HTMLPARAGRAPH_STYLE,
      GTK_TYPE_HTMLPARAGRAPH_ALIGNMENT,
      GTK_TYPE_HTMLFONT_STYLE
} GtkHTMLFundamentalType;

static void php_gtkhtmlstream_destruct(zend_rsrc_list_entry *rsrc TSRMLS_DC);

void php_gtkhtml_register_constants(int module_number TSRMLS_DC)
{

	/* enum GtkHTMLFundamentalType */
	REGISTER_LONG_CONSTANT("GTK_TYPE_HTMLPARAGRAPH_STYLE", GTK_TYPE_HTMLPARAGRAPH_STYLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_TYPE_HTMLPARAGRAPH_ALIGNMENT", GTK_TYPE_HTMLPARAGRAPH_ALIGNMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_TYPE_HTMLFONT_STYLE", GTK_TYPE_HTMLFONT_STYLE, CONST_CS | CONST_PERSISTENT);

	/* enum GtkHTMLParagraphStyle */
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_NORMAL", GTK_HTML_PARAGRAPH_STYLE_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H1", GTK_HTML_PARAGRAPH_STYLE_H1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H2", GTK_HTML_PARAGRAPH_STYLE_H2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H3", GTK_HTML_PARAGRAPH_STYLE_H3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H4", GTK_HTML_PARAGRAPH_STYLE_H4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H5", GTK_HTML_PARAGRAPH_STYLE_H5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_H6", GTK_HTML_PARAGRAPH_STYLE_H6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_ADDRESS", GTK_HTML_PARAGRAPH_STYLE_ADDRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_PRE", GTK_HTML_PARAGRAPH_STYLE_PRE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_ITEMDOTTED", GTK_HTML_PARAGRAPH_STYLE_ITEMDOTTED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_ITEMROMAN", GTK_HTML_PARAGRAPH_STYLE_ITEMROMAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_ITEMDIGIT", GTK_HTML_PARAGRAPH_STYLE_ITEMDIGIT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_STYLE_ITEMALPHA", GTK_HTML_PARAGRAPH_STYLE_ITEMALPHA, CONST_CS | CONST_PERSISTENT);

	/* enum GtkHTMLParagraphAlignment */
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_ALIGNMENT_LEFT", GTK_HTML_PARAGRAPH_ALIGNMENT_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_ALIGNMENT_RIGHT", GTK_HTML_PARAGRAPH_ALIGNMENT_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_PARAGRAPH_ALIGNMENT_CENTER", GTK_HTML_PARAGRAPH_ALIGNMENT_CENTER, CONST_CS | CONST_PERSISTENT);

	/* enum GtkHTMLFontStyle */
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_DEFAULT", GTK_HTML_FONT_STYLE_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_1", GTK_HTML_FONT_STYLE_SIZE_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_2", GTK_HTML_FONT_STYLE_SIZE_2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_3", GTK_HTML_FONT_STYLE_SIZE_3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_4", GTK_HTML_FONT_STYLE_SIZE_4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_5", GTK_HTML_FONT_STYLE_SIZE_5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_6", GTK_HTML_FONT_STYLE_SIZE_6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_7", GTK_HTML_FONT_STYLE_SIZE_7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SIZE_MASK", GTK_HTML_FONT_STYLE_SIZE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_BOLD", GTK_HTML_FONT_STYLE_BOLD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_ITALIC", GTK_HTML_FONT_STYLE_ITALIC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_UNDERLINE", GTK_HTML_FONT_STYLE_UNDERLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_STRIKEOUT", GTK_HTML_FONT_STYLE_STRIKEOUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_FIXED", GTK_HTML_FONT_STYLE_FIXED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SUBSCRIPT", GTK_HTML_FONT_STYLE_SUBSCRIPT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_FONT_STYLE_SUPERSCRIPT", GTK_HTML_FONT_STYLE_SUPERSCRIPT, CONST_CS | CONST_PERSISTENT);

	/* enum GtkHTMLCommandType */
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UNDO", GTK_HTML_COMMAND_UNDO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_REDO", GTK_HTML_COMMAND_REDO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_COPY", GTK_HTML_COMMAND_COPY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_COPY_AND_DISABLE_SELECTION", GTK_HTML_COMMAND_COPY_AND_DISABLE_SELECTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CUT", GTK_HTML_COMMAND_CUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PASTE", GTK_HTML_COMMAND_PASTE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CUT_LINE", GTK_HTML_COMMAND_CUT_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_PARAGRAPH", GTK_HTML_COMMAND_INSERT_PARAGRAPH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_TAB", GTK_HTML_COMMAND_INSERT_TAB, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_RULE", GTK_HTML_COMMAND_INSERT_RULE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_RULE_PARAM", GTK_HTML_COMMAND_INSERT_RULE_PARAM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_IMAGE_PARAM", GTK_HTML_COMMAND_INSERT_IMAGE_PARAM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_TAB_OR_INDENT_MORE", GTK_HTML_COMMAND_INSERT_TAB_OR_INDENT_MORE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MAKE_LINK", GTK_HTML_COMMAND_MAKE_LINK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_REMOVE_LINK", GTK_HTML_COMMAND_REMOVE_LINK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE", GTK_HTML_COMMAND_DELETE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_BACK", GTK_HTML_COMMAND_DELETE_BACK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_BACK_OR_INDENT_DEC", GTK_HTML_COMMAND_DELETE_BACK_OR_INDENT_DEC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECTION_MODE", GTK_HTML_COMMAND_SELECTION_MODE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DISABLE_SELECTION", GTK_HTML_COMMAND_DISABLE_SELECTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_BOLD_ON", GTK_HTML_COMMAND_BOLD_ON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_BOLD_OFF", GTK_HTML_COMMAND_BOLD_OFF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_BOLD_TOGGLE", GTK_HTML_COMMAND_BOLD_TOGGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ITALIC_ON", GTK_HTML_COMMAND_ITALIC_ON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ITALIC_OFF", GTK_HTML_COMMAND_ITALIC_OFF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ITALIC_TOGGLE", GTK_HTML_COMMAND_ITALIC_TOGGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UNDERLINE_ON", GTK_HTML_COMMAND_UNDERLINE_ON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UNDERLINE_OFF", GTK_HTML_COMMAND_UNDERLINE_OFF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UNDERLINE_TOGGLE", GTK_HTML_COMMAND_UNDERLINE_TOGGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_STRIKEOUT_ON", GTK_HTML_COMMAND_STRIKEOUT_ON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_STRIKEOUT_OFF", GTK_HTML_COMMAND_STRIKEOUT_OFF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_STRIKEOUT_TOGGLE", GTK_HTML_COMMAND_STRIKEOUT_TOGGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_MINUS_2", GTK_HTML_COMMAND_SIZE_MINUS_2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_MINUS_1", GTK_HTML_COMMAND_SIZE_MINUS_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_PLUS_0", GTK_HTML_COMMAND_SIZE_PLUS_0, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_PLUS_1", GTK_HTML_COMMAND_SIZE_PLUS_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_PLUS_2", GTK_HTML_COMMAND_SIZE_PLUS_2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_PLUS_3", GTK_HTML_COMMAND_SIZE_PLUS_3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_PLUS_4", GTK_HTML_COMMAND_SIZE_PLUS_4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_INCREASE", GTK_HTML_COMMAND_SIZE_INCREASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SIZE_DECREASE", GTK_HTML_COMMAND_SIZE_DECREASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ALIGN_LEFT", GTK_HTML_COMMAND_ALIGN_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ALIGN_CENTER", GTK_HTML_COMMAND_ALIGN_CENTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ALIGN_RIGHT", GTK_HTML_COMMAND_ALIGN_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INDENT_ZERO", GTK_HTML_COMMAND_INDENT_ZERO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INDENT_INC", GTK_HTML_COMMAND_INDENT_INC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INDENT_INC_OR_NEXT_CELL", GTK_HTML_COMMAND_INDENT_INC_OR_NEXT_CELL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INDENT_DEC", GTK_HTML_COMMAND_INDENT_DEC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INDENT_PARAGRAPH", GTK_HTML_COMMAND_INDENT_PARAGRAPH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_BREAK_AND_FILL_LINE", GTK_HTML_COMMAND_BREAK_AND_FILL_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SPACE_AND_FILL_LINE", GTK_HTML_COMMAND_SPACE_AND_FILL_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_NORMAL", GTK_HTML_COMMAND_PARAGRAPH_STYLE_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H1", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H2", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H3", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H4", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H5", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_H6", GTK_HTML_COMMAND_PARAGRAPH_STYLE_H6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_ADDRESS", GTK_HTML_COMMAND_PARAGRAPH_STYLE_ADDRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_PRE", GTK_HTML_COMMAND_PARAGRAPH_STYLE_PRE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMDOTTED", GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMDOTTED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMROMAN", GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMROMAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMDIGIT", GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMDIGIT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMALPHA", GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMALPHA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_UP", GTK_HTML_COMMAND_MODIFY_SELECTION_UP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_DOWN", GTK_HTML_COMMAND_MODIFY_SELECTION_DOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_LEFT", GTK_HTML_COMMAND_MODIFY_SELECTION_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_RIGHT", GTK_HTML_COMMAND_MODIFY_SELECTION_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_PAGEUP", GTK_HTML_COMMAND_MODIFY_SELECTION_PAGEUP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_PAGEDOWN", GTK_HTML_COMMAND_MODIFY_SELECTION_PAGEDOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_BOL", GTK_HTML_COMMAND_MODIFY_SELECTION_BOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_EOL", GTK_HTML_COMMAND_MODIFY_SELECTION_EOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_BOD", GTK_HTML_COMMAND_MODIFY_SELECTION_BOD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_EOD", GTK_HTML_COMMAND_MODIFY_SELECTION_EOD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_PREV_WORD", GTK_HTML_COMMAND_MODIFY_SELECTION_PREV_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_MODIFY_SELECTION_NEXT_WORD", GTK_HTML_COMMAND_MODIFY_SELECTION_NEXT_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CAPITALIZE_WORD", GTK_HTML_COMMAND_CAPITALIZE_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UPCASE_WORD", GTK_HTML_COMMAND_UPCASE_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DOWNCASE_WORD", GTK_HTML_COMMAND_DOWNCASE_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SPELL_SUGGEST", GTK_HTML_COMMAND_SPELL_SUGGEST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SPELL_PERSONAL_DICTIONARY_ADD", GTK_HTML_COMMAND_SPELL_PERSONAL_DICTIONARY_ADD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SPELL_SESSION_DICTIONARY_ADD", GTK_HTML_COMMAND_SPELL_SESSION_DICTIONARY_ADD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SEARCH", GTK_HTML_COMMAND_SEARCH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SEARCH_INCREMENTAL_FORWARD", GTK_HTML_COMMAND_SEARCH_INCREMENTAL_FORWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SEARCH_INCREMENTAL_BACKWARD", GTK_HTML_COMMAND_SEARCH_INCREMENTAL_BACKWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SEARCH_REGEX", GTK_HTML_COMMAND_SEARCH_REGEX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_FOCUS_FORWARD", GTK_HTML_COMMAND_FOCUS_FORWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_FOCUS_BACKWARD", GTK_HTML_COMMAND_FOCUS_BACKWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_POPUP_MENU", GTK_HTML_COMMAND_POPUP_MENU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_PROPERTIES_DIALOG", GTK_HTML_COMMAND_PROPERTIES_DIALOG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_FORWARD", GTK_HTML_COMMAND_CURSOR_FORWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_BACKWARD", GTK_HTML_COMMAND_CURSOR_BACKWARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_INSERT_TABLE_1_1", GTK_HTML_COMMAND_INSERT_TABLE_1_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_INSERT_COL_AFTER", GTK_HTML_COMMAND_TABLE_INSERT_COL_AFTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_INSERT_COL_BEFORE", GTK_HTML_COMMAND_TABLE_INSERT_COL_BEFORE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_INSERT_ROW_AFTER", GTK_HTML_COMMAND_TABLE_INSERT_ROW_AFTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_INSERT_ROW_BEFORE", GTK_HTML_COMMAND_TABLE_INSERT_ROW_BEFORE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_DELETE_COL", GTK_HTML_COMMAND_TABLE_DELETE_COL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_DELETE_ROW", GTK_HTML_COMMAND_TABLE_DELETE_ROW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_INC_CSPAN", GTK_HTML_COMMAND_TABLE_CELL_INC_CSPAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_DEC_CSPAN", GTK_HTML_COMMAND_TABLE_CELL_DEC_CSPAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_INC_RSPAN", GTK_HTML_COMMAND_TABLE_CELL_INC_RSPAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_DEC_RSPAN", GTK_HTML_COMMAND_TABLE_CELL_DEC_RSPAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_JOIN_LEFT", GTK_HTML_COMMAND_TABLE_CELL_JOIN_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_JOIN_RIGHT", GTK_HTML_COMMAND_TABLE_CELL_JOIN_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_JOIN_UP", GTK_HTML_COMMAND_TABLE_CELL_JOIN_UP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_CELL_JOIN_DOWN", GTK_HTML_COMMAND_TABLE_CELL_JOIN_DOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_INC", GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_INC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_DEC", GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_DEC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_ZERO", GTK_HTML_COMMAND_TABLE_BORDER_WIDTH_ZERO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TEXT_SET_DEFAULT_COLOR", GTK_HTML_COMMAND_TEXT_SET_DEFAULT_COLOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECT_WORD", GTK_HTML_COMMAND_SELECT_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECT_LINE", GTK_HTML_COMMAND_SELECT_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECT_PARAGRAPH", GTK_HTML_COMMAND_SELECT_PARAGRAPH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECT_PARAGRAPH_EXTENDED", GTK_HTML_COMMAND_SELECT_PARAGRAPH_EXTENDED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_SELECT_ALL", GTK_HTML_COMMAND_SELECT_ALL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_POSITION_SAVE", GTK_HTML_COMMAND_CURSOR_POSITION_SAVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_POSITION_RESTORE", GTK_HTML_COMMAND_CURSOR_POSITION_RESTORE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_BOD", GTK_HTML_COMMAND_CURSOR_BOD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_CURSOR_EOD", GTK_HTML_COMMAND_CURSOR_EOD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_BLOCK_REDRAW", GTK_HTML_COMMAND_BLOCK_REDRAW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_UNBLOCK_REDRAW", GTK_HTML_COMMAND_UNBLOCK_REDRAW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ZOOM_IN", GTK_HTML_COMMAND_ZOOM_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ZOOM_OUT", GTK_HTML_COMMAND_ZOOM_OUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_ZOOM_RESET", GTK_HTML_COMMAND_ZOOM_RESET, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_SPACING_INC", GTK_HTML_COMMAND_TABLE_SPACING_INC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_SPACING_DEC", GTK_HTML_COMMAND_TABLE_SPACING_DEC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_SPACING_ZERO", GTK_HTML_COMMAND_TABLE_SPACING_ZERO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_PADDING_INC", GTK_HTML_COMMAND_TABLE_PADDING_INC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_PADDING_DEC", GTK_HTML_COMMAND_TABLE_PADDING_DEC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_TABLE_PADDING_ZERO", GTK_HTML_COMMAND_TABLE_PADDING_ZERO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_TABLE", GTK_HTML_COMMAND_DELETE_TABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_TABLE_ROW", GTK_HTML_COMMAND_DELETE_TABLE_ROW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_TABLE_COLUMN", GTK_HTML_COMMAND_DELETE_TABLE_COLUMN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_DELETE_TABLE_CELL_CONTENTS", GTK_HTML_COMMAND_DELETE_TABLE_CELL_CONTENTS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_COMMAND_GRAB_FOCUS", GTK_HTML_COMMAND_GRAB_FOCUS, CONST_CS | CONST_PERSISTENT);

	/* enum GtkHTMLEditorEventType */
	REGISTER_LONG_CONSTANT("GTK_HTML_EDITOR_EVENT_IMAGE_URL", GTK_HTML_EDITOR_EVENT_IMAGE_URL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_EDITOR_EVENT_DELETE", GTK_HTML_EDITOR_EVENT_DELETE, CONST_CS | CONST_PERSISTENT);

    REGISTER_LONG_CONSTANT("GTK_HTML_STREAM_OK", GTK_HTML_STREAM_OK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_HTML_STREAM_ERROR", GTK_HTML_STREAM_ERROR, CONST_CS | CONST_PERSISTENT);
}

PHP_GTK_EXPORT_CE(gtk_html_ce);
PHP_GTK_EXPORT_CE(gtk_htmlembedded_ce);

/* object GtkHTML  */
PHP_FUNCTION(gtk_html_new)
{
	GtkObject *wrapped_obj;
	char *str = NULL;
	int str_len;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "|s#", &str, &str_len)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	if (str)
		wrapped_obj = (GtkObject *)gtk_html_new_from_string(str, str_len);
	else
		wrapped_obj = (GtkObject *)gtk_html_new();

	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkHTML object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);
}

PHP_FUNCTION(gtk_html_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_html_get_type());
}



						
												
	

 
 
gboolean gtk_htmleditorapi_check_word(GtkHTML *html, const gchar *word,  gpointer data ) {
	zval* callback_data= (zval *) data;
	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
	gboolean gtk_retval = 0;			
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 0, (void **)&cb_check_word);		
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_check_word, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call check_word callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return gtk_retval;			
	}
  
	params = php_gtk_build_value("(s)", word);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_check_word, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		if (zval_is_true(retval))
		   gtk_retval =1;
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
	return gtk_retval;
}

void gtk_htmleditorapi_suggestion_request(GtkHTML *html, const gchar *word, gpointer data ) {
	zval* callback_data= (zval *) data;
	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
		
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 1, (void **)&cb_suggestion_request);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_suggestion_request, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call suggestion_request callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	params = php_gtk_build_value("(s)", word);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_suggestion_request, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
}

void gtk_htmleditorapi_add_to_session(GtkHTML *html, const gchar *word, gpointer data ) {
	zval* callback_data= (zval *) data;
	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
		
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 2, (void **)&cb_add_to_session);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_add_to_session, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call add_to_session callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	params = php_gtk_build_value("(s)", word);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_add_to_session, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
  
}

void gtk_htmleditorapi_add_to_personal(GtkHTML *html, const gchar *word, gpointer data ) {
	zval* callback_data= (zval *) data;

	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
		
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 3, (void **)&cb_add_to_personal);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_add_to_personal, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call add_to_personal callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	params = php_gtk_build_value("(s)", word);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_add_to_personal, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
  
 
}

gboolean gtk_htmleditorapi_command(GtkHTML *html, GtkHTMLCommandType com_type, gpointer data ) {
	zval* callback_data= (zval *) data;

	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
	gboolean gtk_retval = 0;					
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 4, (void **)&cb_command);		
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_command, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call command callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	params = php_gtk_build_value("(i)", (int) com_type);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_command, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		if (zval_is_true(retval))
		   gtk_retval =1;
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
	return gtk_retval;

}


GtkArg *gtk_htmleditorapi_event(GtkHTML *html, GtkHTMLEditorEventType event_type, 
             	GtkArg **gtkargs,	gpointer data ) {
	zval* callback_data= (zval *) data;

	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
	GtkArg *gtk_retval = NULL;					
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
 		
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 5, (void **)&cb_event);			
 	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_event, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call event callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	
	
 	
	switch (event_type) {
		case GTK_HTML_EDITOR_EVENT_COMMAND_BEFORE:
		case GTK_HTML_EDITOR_EVENT_COMMAND_AFTER:
   		case GTK_HTML_EDITOR_EVENT_IMAGE_URL:
			params = php_gtk_build_value("(is)", (int) event_type,(const gchar *) gtkargs[0]); 
			break;
 		case GTK_HTML_EDITOR_EVENT_DELETE:
			params = php_gtk_build_value("(ii)",(int) event_type, 0); 
			break;
		default:
			g_warning ("Unsupported event.\n");
	}
	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_event, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);

	if (retval) {
		if (zval_is_true(retval))
			convert_to_string(retval);
			*GTK_RETLOC_STRING(*gtk_retval) = g_strdup(Z_STRVAL_P(retval));
 		zval_ptr_dtor(&retval);
	}
	zval_ptr_dtor(&params);
	efree(args);

	return gtk_retval;
}
 
GtkWidget *gtk_htmleditorapi_create_input_line(GtkHTML *html,  gpointer data ) {
	
	zval* callback_data= (zval *) data;

	zval *retval = NULL;			
	zval **extra = NULL;			
	zval ***args, *params;			
	char *callback_name;
	GtkWidget *gtk_retval = NULL;					
	 
	zval **cb_check_word = NULL;		
	zval **cb_suggestion_request = NULL;	
	zval **cb_add_to_session = NULL;	
	zval **cb_add_to_personal = NULL;	
	zval **cb_command = NULL;		       
	zval **cb_event = NULL;			
	zval **cb_create_input_line = NULL;	
	zval **callback_filename = NULL;	
	zval **callback_lineno = NULL;		
						
						
	TSRMLS_FETCH();				
 	 					
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 0, (void **)&cb_check_word);		
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 1, (void **)&cb_suggestion_request);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 2, (void **)&cb_add_to_session);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 3, (void **)&cb_add_to_personal);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 4, (void **)&cb_command);		
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 5, (void **)&cb_event);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 6, (void **)&cb_create_input_line);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 7, (void **)&extra);			
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 8, (void **)&callback_filename);	
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 9, (void **)&callback_lineno);		
	
        if (!php_gtk_is_callable(*cb_create_input_line, 0, &callback_name)) {				
		php_error(E_WARNING, 
		    "Unable to call create_input_line callback '%s' specified in %s on line %d",	
		    callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));	
		efree(callback_name);	
		return;			
	}  
	
	// how should this start empty...
	params = php_gtk_build_value("(i)", 0);


	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
 
	call_user_function_ex(EG(function_table), NULL, *cb_command, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);
	/* this should get an object as a return value */
	if (retval) {
		zval_ptr_dtor(&retval);
	}
        zval_ptr_dtor(&params);
	efree(args);
	
	
	return gtk_retval;

}



  
PHP_FUNCTION(gtk_html_set_editor_api)
{
	zval *cb_check_word = NULL;
	zval *cb_suggestion_request = NULL;
	zval *cb_add_to_session = NULL;
	zval *cb_add_to_personal = NULL;
	zval *cb_command = NULL;
	zval *cb_event = NULL;
	zval *cb_create_input_line = NULL;
	
	zval *extra;
	zval *data;
	char *callback_filename;
	uint callback_lineno;
	GtkHTMLEditorAPI *editorapi;

	if (ZEND_NUM_ARGS() < 7) {
		php_error(E_WARNING, "%s() requires at least 7 argument, %d given",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
		return;
	}

	if (!php_gtk_parse_args(1, "VVVVVVV", 
	   	&cb_check_word,
		&cb_suggestion_request,
	   	&cb_add_to_session,
		&cb_add_to_personal,
		&cb_command,
		&cb_event,
		&cb_create_input_line
	   
	   ))	
		return;

	callback_filename = zend_get_executed_filename(TSRMLS_C);
	callback_lineno = zend_get_executed_lineno(TSRMLS_C);
	extra = php_gtk_func_args_as_hash(ZEND_NUM_ARGS(), 7, ZEND_NUM_ARGS());
	
	editorapi = (GtkHTMLEditorAPI *) emalloc(sizeof(GtkHTMLEditorAPI *));
	editorapi->check_word = gtk_htmleditorapi_check_word;
	editorapi->suggestion_request = gtk_htmleditorapi_suggestion_request;
	editorapi->add_to_session = gtk_htmleditorapi_add_to_session;
	editorapi->add_to_personal = gtk_htmleditorapi_add_to_personal;
	editorapi->command = gtk_htmleditorapi_command;
	editorapi->event = gtk_htmleditorapi_event; 
	editorapi->create_input_line = gtk_htmleditorapi_create_input_line;

	data = php_gtk_build_value("(VVVVVVVNsi)", 
		cb_check_word,
		cb_suggestion_request,
	   	cb_add_to_session,
		cb_add_to_personal,
		cb_command,
		cb_event,
		cb_create_input_line, 
		extra, 
		callback_filename, 
		callback_lineno);
		
	gtk_html_set_editor_api(GTK_HTML(PHP_GTK_GET(this_ptr)),
                     editorapi,  data);
 	
 	RETURN_NULL();
 
 
}

PHP_FUNCTION(gtk_html_enable_debug)
{
	zend_bool debug;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &debug))
		return;

	gtk_html_enable_debug(GTK_HTML(PHP_GTK_GET(this_ptr)), (gboolean)debug);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_allow_selection)
{
	zend_bool allow;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &allow))
		return;

	gtk_html_allow_selection(GTK_HTML(PHP_GTK_GET(this_ptr)), (gboolean)allow);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_select_word)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_select_word(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_select_line)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_select_line(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_select_paragraph)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_select_paragraph(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_select_paragraph_extended)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_select_paragraph_extended(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_select_all)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_select_all(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_request_paste)
{
	long selection, type, time;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iii", &selection, &type, &time))
		return;

	gtk_html_request_paste(GTK_HTML(PHP_GTK_GET(this_ptr)), (GdkAtom)selection, (gint)type, (gint32)time);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_begin)
{
	char *content_type;
	php_gtkhtmlstream_s *pgs = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;
	
	pgs   = (php_gtkhtmlstream_s *) emalloc(sizeof(php_gtkhtmlstream_s));
	pgs->gs = gtk_html_begin(GTK_HTML(PHP_GTK_GET(this_ptr)));

	ZEND_REGISTER_RESOURCE(return_value, pgs, le_gtkhtmlstream);
	pgs->id = Z_LVAL_P(return_value);        
}
PHP_FUNCTION(gtk_html_begin_content)
{
	char *content_type;
	php_gtkhtmlstream_s *pgs = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &content_type))
		return;

	pgs   = (php_gtkhtmlstream_s *) emalloc(sizeof(php_gtkhtmlstream_s));
	pgs->gs = gtk_html_begin_content(GTK_HTML(PHP_GTK_GET(this_ptr)), content_type);

	ZEND_REGISTER_RESOURCE(return_value, pgs, le_gtkhtmlstream);
	pgs->id = Z_LVAL_P(return_value);
}
 
PHP_FUNCTION(gtk_html_write)
{
	zval **arg1, **arg2, **arg3=NULL;
	int ret, type,i;
	int num_bytes;
	int issock=0;
	int socketd=0;
	char *string;
	void *what;
	php_gtkhtmlstream_s *pgs;

	switch (ZEND_NUM_ARGS()) {
		case 2:
			if (zend_get_parameters_ex(2, &arg1, &arg2)==FAILURE) {
				RETURN_FALSE;
			}
			convert_to_string_ex(arg2);
			num_bytes = Z_STRLEN_PP(arg2);
			break;

		case 3:
			if (zend_get_parameters_ex(3, &arg1, &arg2, &arg3)==FAILURE) {
				RETURN_FALSE;
			}
			convert_to_string_ex(arg2);
			convert_to_long_ex(arg3);
			num_bytes = MIN(Z_LVAL_PP(arg3), Z_STRLEN_PP(arg2)); 
			/*		num_bytes = Z_LVAL_PP(arg3); */
			break;
			
		default:
			WRONG_PARAM_COUNT;
			/* NOTREACHED */
			break;
	}

	what = zend_fetch_resource(arg1 TSRMLS_CC, -1, "GtkHTMLStream", &type, 1, le_gtkhtmlstream);
	ZEND_VERIFY_RESOURCE(what);
	pgs = (php_gtkhtmlstream_s *) what;
 
	if (!arg3 && PG(magic_quotes_runtime)) {
		zval_copy_ctor(*arg2);
		php_stripslashes(Z_STRVAL_PP(arg2), &num_bytes TSRMLS_CC);
	}
 	/* php_error(E_WARNING, "write using %p (size %d) ", pgs->gs, num_bytes);  */
	// spec says (size_t) size 

        /* 
	string = Z_STRVAL_PP(arg2);
	for (i=0;i<num_bytes;i++) {
	  php_error(E_WARNING, "OUT: %p  %2x ", pgs->gs, string[i]); 
	}
        */
	gtk_html_write(GTK_HTML(PHP_GTK_GET(this_ptr)),
				   pgs->gs,  Z_STRVAL_PP(arg2), num_bytes);
 		
 	RETURN_NULL();
}
PHP_FUNCTION(gtk_html_end)
{
	GtkHTMLStreamStatus status;
	zval *php_status = NULL;
	zval *gs_zval;
	php_gtkhtmlstream_s *pgs;
	int resource_type;
	char *buffer;
	long  size;
        
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "rV", &gs_zval, &php_status))
		return;
        
	if (php_status) {
		status = (GtkHTMLStreamStatus) php_status;
	}
	
	pgs = (php_gtkhtmlstream_s *) zend_list_find(Z_RESVAL_P(gs_zval), &resource_type);
	if (!pgs || resource_type != le_gtkhtmlstream) {
		php_error(E_WARNING,"html_end needs a valid htmlstream resource");
		return;
	}
         
	gtk_html_end(GTK_HTML(PHP_GTK_GET(this_ptr)), pgs->gs, status);

  	zend_list_delete(Z_RESVAL_P(gs_zval));
  
 	RETURN_NULL();
}

PHP_FUNCTION(gtk_html_load_empty)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_load_empty(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_load_from_string)
{
	char *text;
	long text_length;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "si", &text, &text_length))
		return;

	gtk_html_load_from_string(GTK_HTML(PHP_GTK_GET(this_ptr)), text, (gint)text_length);
	RETURN_NULL();
}


static void php_gtk_html_save_callback(HTMLEngine *engine, gchar *string, guint string_len, zval* callback_data)
{
	zval *retval = NULL;
	zval **callback = NULL, **extra = NULL;
	zval **callback_filename = NULL, **callback_lineno = NULL;
	zval ***args, *params;
	char *callback_name;
	TSRMLS_FETCH();

	zend_hash_index_find(Z_ARRVAL_P(callback_data), 0, (void **)&callback);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 1, (void **)&extra);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 2, (void **)&callback_filename);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 3, (void **)&callback_lineno);

	if (!php_gtk_is_callable(*callback, 0, &callback_name)) {
		php_error(E_WARNING, "Unable to call html save callback '%s' specified in %s on line %d", callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));
		efree(callback_name);
		return;
	}

	params = php_gtk_build_value("(s)", string);

	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params); 	 
	
	call_user_function_ex(EG(function_table), NULL, *callback, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);
	if (retval)
		zval_ptr_dtor(&retval);
	efree(args);
	zval_ptr_dtor(&params);

}

PHP_FUNCTION(gtk_html_save)
{

	zval *callback = NULL;
	zval *extra;
	zval *data;
	char *callback_filename;
	uint callback_lineno;

	if (ZEND_NUM_ARGS() < 1) {
		php_error(E_WARNING, "%s() requires at least 1 arguments, %d given",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
		return;
	}

	if (!php_gtk_parse_args(1, "V", &callback))
		return;

	callback_filename = zend_get_executed_filename(TSRMLS_C);
	callback_lineno = zend_get_executed_lineno(TSRMLS_C);
	extra = php_gtk_func_args_as_hash(ZEND_NUM_ARGS(), 1, ZEND_NUM_ARGS());
	data = php_gtk_build_value("(VNsi)", callback, extra, callback_filename, callback_lineno);
	RETURN_BOOL(gtk_html_save(GTK_HTML(PHP_GTK_GET(this_ptr)),
                     (GtkHTMLSaveReceiverFn) php_gtk_html_save_callback,  data));
}

static void php_gtk_html_url_request_callback (GtkHTML *html, const char *url, GtkHTMLStream *gs, zval* callback_data) 
{

	php_gtkhtmlstream_s *pgs;
	zval *myresource = NULL; 
	zval *retval = NULL;
	zval **callback = NULL, **extra = NULL;
	zval **callback_filename = NULL, **callback_lineno = NULL;
	zval ***args, *params;
	char *callback_name;
	long gs_id;

	TSRMLS_FETCH();

 	/* php_error(E_WARNING, "url request recieved %p as handle ", gs); */
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 0, (void **)&callback);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 1, (void **)&extra);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 2, (void **)&callback_filename);
	zend_hash_index_find(Z_ARRVAL_P(callback_data), 3, (void **)&callback_lineno);

	if (!php_gtk_is_callable(*callback, 0, &callback_name)) {
		php_error(E_WARNING, "Unable to call url_request callback '%s' specified in %s on line %d", callback_name, Z_STRVAL_PP(callback_filename), Z_LVAL_PP(callback_lineno));
		efree(callback_name);
		return;
	}

	params = php_gtk_build_value("(s)", url);
	/* php_error(E_WARNING, "Using RESORUCE id %p ",gs_id); */
        pgs   = (php_gtkhtmlstream_s *) emalloc(sizeof(php_gtkhtmlstream_s));
	pgs->gs = gs;
	MAKE_STD_ZVAL(myresource);
	gs_id = zend_list_insert(pgs, le_gtkhtmlstream);
	pgs->id = gs_id;
	ZVAL_RESOURCE(myresource, gs_id);
	
	zend_hash_next_index_insert(Z_ARRVAL_P(params), &myresource, sizeof(zval *), NULL);
	
	if (extra)
		php_array_merge(Z_ARRVAL_P(params), Z_ARRVAL_PP(extra), 0);
		
	args = php_gtk_hash_as_array(params);
	
	call_user_function_ex(EG(function_table), NULL, *callback, &retval, zend_hash_num_elements(Z_ARRVAL_P(params)), args, 0, NULL TSRMLS_CC);
	if (retval)
		zval_ptr_dtor(&retval);
	efree(args);
	zval_ptr_dtor(&params);

}

PHP_FUNCTION(gtk_html_connect_url_request)
{
	zval *callback = NULL;
	zval *extra;
	zval *data;
	char *callback_filename;
	uint callback_lineno;

	if (ZEND_NUM_ARGS() < 1) {
		php_error(E_WARNING, "%s() requires at least 1 arguments, %d given",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
		return;
	}

	if (!php_gtk_parse_args(1, "V", &callback))
		return;

	callback_filename = zend_get_executed_filename(TSRMLS_C);
	callback_lineno = zend_get_executed_lineno(TSRMLS_C);
	extra = php_gtk_func_args_as_hash(ZEND_NUM_ARGS(), 1, ZEND_NUM_ARGS());
	data = php_gtk_build_value("(VNsi)", callback, extra, callback_filename, callback_lineno);
	RETURN_LONG(gtk_signal_connect (GTK_OBJECT(GTK_HTML(PHP_GTK_GET(this_ptr))), "url_requested",
			    GTK_SIGNAL_FUNC (php_gtk_html_url_request_callback), data));
 
}
 
PHP_FUNCTION(gtk_html_export)
{

	zval *callback = NULL;
	
	zval *extra;
	zval *data;
	char *callback_filename;
        char *type;
	uint callback_lineno;

	if (ZEND_NUM_ARGS() < 1) {
		php_error(E_WARNING, "%s() requires at least 1 arguments, %d given",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
		return;
	}

	if (!php_gtk_parse_args(1, "sV", &type,&callback))
		return;

	callback_filename = zend_get_executed_filename(TSRMLS_C);
	callback_lineno = zend_get_executed_lineno(TSRMLS_C);
	extra = php_gtk_func_args_as_hash(ZEND_NUM_ARGS(), 2, ZEND_NUM_ARGS());
	data = php_gtk_build_value("(VNsi)", callback, extra, callback_filename, callback_lineno);
	RETURN_BOOL(gtk_html_export(GTK_HTML(PHP_GTK_GET(this_ptr)), type,
                     (GtkHTMLSaveReceiverFn) php_gtk_html_save_callback,  data));
}

PHP_FUNCTION(gtk_html_set_editable)
{
	zend_bool editable;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &editable))
		return;

	gtk_html_set_editable(GTK_HTML(PHP_GTK_GET(this_ptr)), (gboolean)editable);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_get_editable)
{
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_html_get_editable(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_html_get_title)
{
	const gchar *ret;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	ret = gtk_html_get_title(GTK_HTML(PHP_GTK_GET(this_ptr)));
	if (ret) {
		RETURN_STRING((char *)ret, 1);
	}
	else {
		RETURN_NULL();
	}
}


PHP_FUNCTION(gtk_html_jump_to_anchor)
{
	char *anchor;
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &anchor))
		return;

	php_retval = gtk_html_jump_to_anchor(GTK_HTML(PHP_GTK_GET(this_ptr)), anchor);
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_html_get_paragraph_style)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_html_get_paragraph_style(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_html_set_paragraph_style)
{
	GtkHTMLParagraphStyle style;
	zval *php_style = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_style))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_html_set_paragraph_style(GTK_HTML(PHP_GTK_GET(this_ptr)), style);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_set_indent)
{
	long level;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &level))
		return;

	gtk_html_set_indent(GTK_HTML(PHP_GTK_GET(this_ptr)), (gint)level);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_modify_indent_by_delta)
{
	long delta;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &delta))
		return;

	gtk_html_modify_indent_by_delta(GTK_HTML(PHP_GTK_GET(this_ptr)), (gint)delta);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_set_font_style)
{
	GtkHTMLFontStyle and_mask, or_mask;
	zval *php_and_mask = NULL, *php_or_mask = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VV", &php_and_mask, &php_or_mask))
		return;

	if (php_and_mask && !php_gtk_get_simple_enum_value(php_and_mask, (gint *)&and_mask)) {
		return;
	}

	if (php_or_mask && !php_gtk_get_simple_enum_value(php_or_mask, (gint *)&or_mask)) {
		return;
	}

	gtk_html_set_font_style(GTK_HTML(PHP_GTK_GET(this_ptr)), and_mask, or_mask);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_set_color) 
{

	gushort r,g,b;
	HTMLColor *hcolor = NULL;
	GdkColor color;
	gchar *color_spec;
	
	NOT_STATIC_METHOD();
	
	switch (ZEND_NUM_ARGS()) {
	case 1:
		if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &color_spec)) {
			php_error(E_WARNING, "%s() should recieve either string #rrggbb or r,g,b",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
			return;	  
		}
		if (!gdk_color_parse(color_spec, &color)) {
			php_error(E_WARNING, "%s() could not parse color spec '%s'", get_active_function_name(TSRMLS_C), color_spec);
			return;
		}
		hcolor =  (HTMLColor *) html_color_new_from_gdk_color(&color);
		break;
	case 3:
		if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "hhh", &r,&g,&b)) {
			php_error(E_WARNING, "%s() should recieve either string #rrggbb or r,g,b",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
			return;			
		}	
		hcolor =  (HTMLColor *) html_color_new_from_rgb(r, g, b);
		break;
	default:
		WRONG_PARAM_COUNT;
		/* NOTREACHED */
		break;
	}
	gtk_html_set_color(GTK_HTML(PHP_GTK_GET(this_ptr)), hcolor);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_html_toggle_font_style)
{
	GtkHTMLFontStyle style;
	zval *php_style = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_style))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_html_toggle_font_style(GTK_HTML(PHP_GTK_GET(this_ptr)), style);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_get_paragraph_alignment)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_html_get_paragraph_alignment(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_html_set_paragraph_alignment)
{
	GtkHTMLParagraphAlignment alignment;
	zval *php_alignment = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_alignment))
		return;

	if (php_alignment && !php_gtk_get_simple_enum_value(php_alignment, (gint *)&alignment)) {
		return;
	}

	gtk_html_set_paragraph_alignment(GTK_HTML(PHP_GTK_GET(this_ptr)), alignment);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_cut)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_cut(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_copy)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_copy(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_paste)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_paste(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_undo)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_undo(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_redo)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_redo(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_insert_html)
{
	char *html_src;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &html_src))
		return;

	gtk_html_insert_html(GTK_HTML(PHP_GTK_GET(this_ptr)), html_src);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_set_default_background_color) 
{

 	gushort r,g,b;
	GdkColor color;
	GdkColor lcolor;
	gchar *color_spec;
	
	NOT_STATIC_METHOD();
	
	switch (ZEND_NUM_ARGS()) {
	case 1:
		if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &color_spec)) {
			php_error(E_WARNING, "%s() should recieve either string #rrggbb or r,g,b",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
			return;	
		}	  
		if (!gdk_color_parse(color_spec, &color)) {
			php_error(E_WARNING, "%s() could not parse color spec '%s'", get_active_function_name(TSRMLS_C), color_spec);
			return;
		}
		break;
	case 3:
		if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "hhh", &color.red,&color.green,&color.blue)) {
			php_error(E_WARNING, "%s() should recieve either string #rrggbb or r,g,b",
				  get_active_function_name(TSRMLS_C), ZEND_NUM_ARGS());
			return;	
		}	
		break;
	default:
		WRONG_PARAM_COUNT;
		/* NOTREACHED */
		break;
	}
	gtk_html_set_default_background_color(GTK_HTML(PHP_GTK_GET(this_ptr)), &color);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_html_set_default_content_type)
{
	char *content_type;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &content_type))
		return;

	gtk_html_set_default_content_type(GTK_HTML(PHP_GTK_GET(this_ptr)), content_type);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_get_object_by_id)
{
	char *id;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &id))
		return;

	gtk_html_get_object_by_id(GTK_HTML(PHP_GTK_GET(this_ptr)), id);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_command)
{
	char *command_name;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &command_name))
		return;

	gtk_html_command(GTK_HTML(PHP_GTK_GET(this_ptr)), command_name);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_edit_make_cursor_visible)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_edit_make_cursor_visible(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_set_magnification)
{
	double magnification;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "d", &magnification))
		return;

	gtk_html_set_magnification(GTK_HTML(PHP_GTK_GET(this_ptr)), magnification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_zoom_in)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_zoom_in(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_zoom_out)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_zoom_out(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_zoom_reset)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_zoom_reset(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_html_update_styles)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_html_update_styles(GTK_HTML(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}

/* some more cool stuff - direct access! */
PHP_FUNCTION(gtk_html_get_font_style)
{
        
        GtkHTMLFontStyle php_retval;
        GdkColor *result_obj;
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = html_engine_get_font_style(GTK_HTML(PHP_GTK_GET(this_ptr))->engine);
	RETURN_LONG((long) php_retval);
}

PHP_FUNCTION(gtk_html_get_font_color)
{
        
        HTMLColor *hcolor = NULL;
        
        NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;
        hcolor = html_engine_get_color(GTK_HTML(PHP_GTK_GET(this_ptr))->engine);
        
        *return_value = *php_gdk_color_new(&hcolor->color);
	 
}

/* direct copy from gtkhtml.c */

static GtkWidget *
php_gtk_shift_to_iframe_parent (GtkWidget *widget, gint *x, gint *y)
{
	while (GTK_HTML (widget)->iframe_parent) {
		if (x)
			*x += widget->allocation.x;
		if (y)
			*y += widget->allocation.y;
		widget = GTK_HTML (widget)->iframe_parent;
	}

	return widget;
}


PHP_FUNCTION(gtk_html_set_cursor_xy)
{
	GtkWidget *widget;
	HTMLEngine *engine;
	gint x, y;
     
	NOT_STATIC_METHOD();
	
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &x,&y))
		return;
        
	/* from shift_to_iframe_parent - not exposed by headers */
	widget = GTK_WIDGET(PHP_GTK_GET(this_ptr));
	widget = php_gtk_shift_to_iframe_parent (widget, &x, &y);

	engine = GTK_HTML (widget)->engine;
	if (GTK_HTML (widget)->button1_pressed && html_engine_get_editable (engine))
		html_engine_jump_at (engine,
				     x + engine->x_offset,
				     y + engine->y_offset);
	
	RETURN_NULL();
}

PHP_FUNCTION(gtk_html_insert_link)
{
	gchar *url = NULL;
	gchar *target = NULL;
	int urllen=0;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s#s", &url, &urllen, &target))
		return;
		
        if (urllen > 0) {
  	  html_engine_insert_link(GTK_HTML(PHP_GTK_GET(this_ptr))->engine, url, target);
	} else {
	    html_engine_insert_link(GTK_HTML(PHP_GTK_GET(this_ptr))->engine, NULL,NULL);
	}  
	RETURN_NULL();
}
PHP_FUNCTION(gtk_html_get_url)
{
	const gchar *ret = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	/* if (html_engine_is_selection_active (  GTK_HTML(PHP_GTK_GET(this_ptr))->engine))  */
	ret = html_engine_get_url(  GTK_HTML(PHP_GTK_GET(this_ptr))->engine);
	if (ret) {
		RETURN_STRING((char *)ret, 1);
	}
	else {
		RETURN_NULL();
	}
}

PHP_FUNCTION(gtk_html_get_target)
{
	const gchar *ret = NULL;
        
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	/* if (html_engine_is_selection_active (  GTK_HTML(PHP_GTK_GET(this_ptr))->engine))  */
	ret = html_engine_get_target( GTK_HTML(PHP_GTK_GET(this_ptr))->engine );
	if (ret) {
		RETURN_STRING((char *)ret, 1);
	}
	else {
		RETURN_NULL();
	}
}

static function_entry php_gtk_html_functions[] = {
	{"GtkHTML",	PHP_FN(gtk_html_new),	NULL},
	{"gtkhtml",	PHP_FN(gtk_html_new),	NULL},
	{"get_type",	PHP_FN(gtk_html_get_type),	NULL},
	{"gtk_html_set_editor_api",	PHP_FN(gtk_html_set_editor_api),	NULL},
	{"gtk_html_enable_debug",	PHP_FN(gtk_html_enable_debug),	NULL},
	{"allow_selection",	PHP_FN(gtk_html_allow_selection),	NULL},
	{"select_word",	PHP_FN(gtk_html_select_word),	NULL},
	{"select_line",	PHP_FN(gtk_html_select_line),	NULL},
	{"select_paragraph",	PHP_FN(gtk_html_select_paragraph),	NULL},
	{"select_paragraph_extended",	PHP_FN(gtk_html_select_paragraph_extended),	NULL},
	{"select_all",	PHP_FN(gtk_html_select_all),	NULL},
	{"request_paste",	PHP_FN(gtk_html_request_paste),	NULL},
	{"begin",	PHP_FN(gtk_html_begin),	NULL},
	{"begin_content",	PHP_FN(gtk_html_begin_content),	NULL},
	{"write",	PHP_FN(gtk_html_write),	NULL},
	{"end",	PHP_FN(gtk_html_end),	NULL},
	{"load_empty",	PHP_FN(gtk_html_load_empty),	NULL},
	{"load_from_string",	PHP_FN(gtk_html_load_from_string),	NULL},
	{"save",	PHP_FN(gtk_html_save),	NULL},
	{"connect_url_request",	PHP_FN(gtk_html_connect_url_request),	NULL},
	{"export",	PHP_FN(gtk_html_export),	NULL},
	{"set_editable",	PHP_FN(gtk_html_set_editable),	NULL},
	{"get_editable",	PHP_FN(gtk_html_get_editable),	NULL},
	{"get_title",	PHP_FN(gtk_html_get_title),	NULL},
	{"jump_to_anchor",	PHP_FN(gtk_html_jump_to_anchor),	NULL},
	{"get_paragraph_style",	PHP_FN(gtk_html_get_paragraph_style),	NULL},
	{"set_paragraph_style",	PHP_FN(gtk_html_set_paragraph_style),	NULL},
	{"set_indent",	PHP_FN(gtk_html_set_indent),	NULL},
	{"modify_indent_by_delta",	PHP_FN(gtk_html_modify_indent_by_delta),	NULL},
	{"set_font_style",	PHP_FN(gtk_html_set_font_style),	NULL},
	{"set_color",	PHP_FN(gtk_html_set_color),	NULL},
	{"toggle_font_style",	PHP_FN(gtk_html_toggle_font_style),	NULL},
	{"get_paragraph_alignment",	PHP_FN(gtk_html_get_paragraph_alignment),	NULL},
	{"set_paragraph_alignment",	PHP_FN(gtk_html_set_paragraph_alignment),	NULL},
	{"cut",	PHP_FN(gtk_html_cut),	NULL},
	{"copy",	PHP_FN(gtk_html_copy),	NULL},
	{"paste",	PHP_FN(gtk_html_paste),	NULL},
	{"undo",	PHP_FN(gtk_html_undo),	NULL},
	{"redo",	PHP_FN(gtk_html_redo),	NULL},
	{"insert_html",	PHP_FN(gtk_html_insert_html),	NULL},
	{"set_default_background_color",	PHP_FN(gtk_html_set_default_background_color),	NULL},
	{"set_default_content_type",	PHP_FN(gtk_html_set_default_content_type),	NULL},
	{"get_object_by_id",	PHP_FN(gtk_html_get_object_by_id),	NULL},
	{"command",	PHP_FN(gtk_html_command),	NULL},
	{"edit_make_cursor_visible",	PHP_FN(gtk_html_edit_make_cursor_visible),	NULL},
	{"set_magnification",	PHP_FN(gtk_html_set_magnification),	NULL},
	{"zoom_in",	PHP_FN(gtk_html_zoom_in),	NULL},
	{"zoom_out",	PHP_FN(gtk_html_zoom_out),	NULL},
	{"zoom_reset",	PHP_FN(gtk_html_zoom_reset),	NULL},
	{"update_styles",	PHP_FN(gtk_html_update_styles),	NULL},
	{"get_font_style",	PHP_FN(gtk_html_get_font_style),	NULL},
	{"get_font_color",	PHP_FN(gtk_html_get_font_color),	NULL},
	{"set_cursor_xy",	PHP_FN(gtk_html_set_cursor_xy),	NULL},
	{"insert_link",	PHP_FN(gtk_html_insert_link),	NULL},
	{"get_url",	PHP_FN(gtk_html_get_url),	NULL},
	{"get_target",	PHP_FN(gtk_html_get_target),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkHTMLEmbedded  */

PHP_FUNCTION(gtk_html_embedded_new)
{
	char *classid, *name, *type, *data;
	long width, height;
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ssssii", &classid, &name, &type, &data, &width, &height)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_html_embedded_new(classid, name, type, data, (int)width, (int)height);
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkHTMLEmbedded object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_htmlembedded_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_htmlembedded_get_type());
}


static function_entry php_gtk_htmlembedded_functions[] = {
	{"GtkHTMLEmbedded",	PHP_FN(gtk_html_embedded_new),	NULL},
	{"gtkhtmlembedded",	PHP_FN(gtk_html_embedded_new),	NULL},
	{"get_type",	PHP_FN(gtk_htmlembedded_get_type),	NULL},
	{NULL, NULL, NULL}
};


void php_gtkhtml_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkHTML", php_gtk_html_functions, NULL, NULL, php_gtk_set_property);
	gtk_html_ce = zend_register_internal_class_ex(&ce, gtk_layout_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkHTML"), gtk_html_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkHTMLEmbedded", php_gtk_htmlembedded_functions, NULL, NULL, php_gtk_set_property);
	gtk_htmlembedded_ce = zend_register_internal_class_ex(&ce, gtk_bin_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkHTMLEmbedded"), gtk_htmlembedded_ce);


}

#endif /* HAVE_PHP_GTK */
